"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_directive_1 = require("./base.directive");
var directive_1 = require("../decorators/directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var angular_service_1 = require("../services/angular.service");
var DateTimePickerDirective = /** @class */ (function (_super) {
    tslib_1.__extends(DateTimePickerDirective, _super);
    function DateTimePickerDirective(filter) {
        var _this = _super.call(this) || this;
        _this.filter = filter;
        return _this;
    }
    DateTimePickerDirective_1 = DateTimePickerDirective;
    DateTimePickerDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var options = {};
        //////////////////////////////////////////////////////////////////
        // Own properties
        //////////////////////////////////////////////////////////////////
        this.tryGet(options, instanceAttributes, "format");
        this.tryGet(options, instanceAttributes, "dayViewHeaderFormat");
        this.tryGetBoolean(options, instanceAttributes, "extraFormats");
        this.tryGetNumber(options, instanceAttributes, "stepping");
        this.tryGetDate(options, instanceAttributes, "minDate");
        this.tryGetDate(options, instanceAttributes, "maxDate");
        this.tryGetBoolean(options, instanceAttributes, "useCurrent");
        this.tryGetBoolean(options, instanceAttributes, "collapse");
        this.tryGet(options, instanceAttributes, "locale");
        this.tryGet(options, instanceAttributes, "viewMode");
        this.tryGetDate(options, instanceAttributes, "defaultDate");
        this.tryGetBoolean(options, instanceAttributes, "disabledDates");
        this.tryGetBoolean(options, instanceAttributes, "enabledDates");
        this.tryGetBoolean(options, instanceAttributes, "disabledHours");
        this.tryGetBoolean(options, instanceAttributes, "disabledTimeIntervals");
        this.tryGetBoolean(options, instanceAttributes, "useStrict");
        this.tryGetBoolean(options, instanceAttributes, "sideBySide");
        this.tryGetBoolean(options, instanceAttributes, "calendarWeeks");
        this.tryGet(options, instanceAttributes, "toolbarPlacement");
        this.tryGetBoolean(options, instanceAttributes, "showTodayButton");
        this.tryGetBoolean(options, instanceAttributes, "showClear");
        this.tryGetBoolean(options, instanceAttributes, "showClose");
        this.tryGetBoolean(options, instanceAttributes, "keepOpen");
        this.tryGetBoolean(options, instanceAttributes, "allowInputToggle");
        this.tryGetBoolean(options, instanceAttributes, "focusOnShow");
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(instanceAttributes["maxDateToday"]))
            options.maxDate = new Date();
        instanceElement["datetimepicker"](options);
        instanceElement.on("dp.change", function (e) {
            if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.format) || options.format === "L")
                controller.$setViewValue(!paradigm_ui_web_shared_1.ObjectExtensions.isNull(e["date"])
                    ? _this.filter("date")(e["date"]._d, "MM/dd/yyyy")
                    : null);
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.format) && options.format === "LT")
                controller.$setViewValue(!paradigm_ui_web_shared_1.ObjectExtensions.isNull(e["date"])
                    ? _this.filter("date")(e["date"]._d, "hh:mm")
                    : null);
        });
        instanceElement.on("dp.show", function () {
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.viewMode)) {
                instanceElement.data("DateTimePicker").viewMode(options.viewMode);
            }
        });
    };
    DateTimePickerDirective.factory = function (filter) {
        return new DateTimePickerDirective_1(filter);
    };
    DateTimePickerDirective = DateTimePickerDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "dateTimePicker",
            restrict: "A",
            require: "ngModel",
            dependencies: [angular_service_1.AngularServices.filter]
        })
    ], DateTimePickerDirective);
    return DateTimePickerDirective;
    var DateTimePickerDirective_1;
}(base_directive_1.DirectiveBase));
exports.DateTimePickerDirective = DateTimePickerDirective;
