"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var ScrollToBottomDirective = /** @class */ (function (_super) {
    tslib_1.__extends(ScrollToBottomDirective, _super);
    function ScrollToBottomDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ScrollToBottomDirective_1 = ScrollToBottomDirective;
    ScrollToBottomDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var options = {};
        this.tryGetBoolean(options, instanceAttributes, "onContentChange");
        this.tryGetBoolean(options, instanceAttributes, "onClick");
        if (options.onContentChange) {
            scope.$watch(function () { return instanceElement[0].innerHTML; }, function () { return instanceElement.scrollTop(instanceElement[0].scrollHeight); });
        }
        if (options.onClick) {
            instanceElement.on("click", function () { return instanceElement.scrollTop(0); });
        }
    };
    ScrollToBottomDirective.factory = function () {
        return new ScrollToBottomDirective_1();
    };
    ScrollToBottomDirective = ScrollToBottomDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "scrollToBottom",
            restrict: "A"
        })
    ], ScrollToBottomDirective);
    return ScrollToBottomDirective;
    var ScrollToBottomDirective_1;
}(base_directive_1.DirectiveBase));
exports.ScrollToBottomDirective = ScrollToBottomDirective;
